-- Author      : ketch
-- Create Date : 11/19/2020 12:54:22 PM

local addonname, NS_WishLists_Master = ...
local _G = getfenv(0)
local NS_WishLists_Master =_G.NS_WishLists_Master
local initialOptionsFrame


NS_WishLists_Master.MinimapBtn = LibStub("LibDataBroker-1.1"):NewDataObject(addonname, {
    type = "data source",
    text = addonname,
    icon = "Interface\\AddOns\\"..addonname.."\\Images\\brabbit1",
    OnClick = function(self, button)
	    if (button == "LeftButton") then
            if fr_shown then
                if NS_WishLists_Master.frame then NS_WishLists_Master.frame:Hide() end
            else
                if NS_WishLists_Master.frame then NS_WishLists_Master.frame:Show() else NS_WishLists_Master:Show() end
            end 
            NS_WishLists_Master.mainFrameIsVisible = not NS_WishLists_Master.mainFrameIsVisible
        else
           
        end
    end,
    OnTooltipShow = function(tooltip)
        if not tooltip or not tooltip.AddLine then return end
        tooltip:AddLine(addonname)
    end,
})

function NS_WishLists_Master:Config_OnInitialize()
    if NS_WishLists_Master_Data_001.displayError == nil then
        NS_WishLists_Master_Data_001.displayError = {
            ["hide"] = false,
        }
    end
    if NS_WishLists_Master_Data_001.displayOnlyHimHer == nil then
        NS_WishLists_Master_Data_001.displayOnlyHimHer = false
    end
    if NS_WishLists_Master_Data_001.minimapPos == nil then
        NS_WishLists_Master_Data_001.minimapPos = {
            ["minimapPos"] = 90,
            ["hide"] = false,
        }
    end
    NS_WishLists_Master.icon:Register(addonname, NS_WishLists_Master.MinimapBtn , NS_WishLists_Master_Data_001.minimapPos)
end

function NS_WishLists_Master:Config_UpdateOptions()
    NS_WishLists_Master.AceRegistry:NotifyChange(addonname)
end

function NS_WishLists_Master:Config_Show()
    if( not InterfaceOptionsFrame:IsVisible() ) then
        InterfaceOptionsFrame_Show()
    end
    NS_WishLists_Master:Config_UpdateOptions()
    InterfaceOptionsFrame_OpenToCategory(initialOptionsFrame)
end

-- Setup the options frame parent
local containerFrame = CreateFrame("Frame", nil, InterfaceOptionsFrame)
    containerFrame.name = addonname
    containerFrame:SetScript("OnShow", function()
        NS_WishLists_Master:Config_Show() 
    end)

    containerFrame:Hide()
InterfaceOptions_AddCategory(containerFrame)
NS_WishLists_Master.version = GetAddOnMetadata(addonname, "Version")
-- Create the options menu child frames
NS_WishLists_Master.options = {
    type = "group",
    name = format("%s |cffADFF2F%s|r", addonname, NS_WishLists_Master.version),
    args = {
        general = {
            type = "group",
            order = 1,
            name = "General",
            set = function(info, value)
                --NS_WishLists_Master_Data_001.db.profile[info[#(info)]] = value
            end,
            get = function(info)
                --return v--NS_WishLists_Master_Data_001.db.profile[info[#(info)]]
            end,
            args = {
                hideMinimap = {
                    order = 1,
                    type = "toggle",
                    name = "Hide minimap button",
                    desc = "Hide the minimap button.",
                    width = "full",
                    set = function(info, value)
                        NS_WishLists_Master_Data_001.minimap.hide = not NS_WishLists_Master_Data_001.minimap.hide
                        local LDI = LibStub("LibDBIcon-1.0", true)
                        if( LDI ) then
                            if( NS_WishLists_Master_Data_001.minimap.hide ) then
                                LDI:Hide("NS_WishLists_Master!")
                            else
                                LDI:Show("NS_WishLists_Master!")
                            end
                        end
                    end,
                    get = function(info)
                        return NS_WishLists_Master_Data_001.minimap.hide
                    end,
                },
                displayError = {
                    order = 2,
                    type = "toggle",
                    name = "Display errors",
                    desc = "Display error from com data.",
                    width = "full",
                    set = function(info, value)
                        NS_WishLists_Master_Data_001.displayError.hide = not NS_WishLists_Master_Data_001.displayError.hide                                                
                    end,
                    get = function(info)
                        return NS_WishLists_Master_Data_001.displayError.hide
                    end,
                }
            }
        },
    },
}

NS_WishLists_Master.AceConfig:RegisterOptionsTable(addonname, NS_WishLists_Master.options)
initialOptionsFrame = NS_WishLists_Master.AceConfigDialog:AddToBlizOptions(addonname, NS_WishLists_Master.options.args.general.name, addonname, "general")




