-- Author      : ketch
-- Create Date : 12/12/2020 4:43:04 AM


local addonname, NSCom = ...
local _G = getfenv(0)
local NS_WishLists_Master =_G.NS_WishLists_Master
local checkbox_height = 19
local clr_lines = {
    r =0.2,
    g = 0.2,
    b = 0.4,
    a = 0.2
}
local drk_lines = {
    r =0.4,
    g = 0.4,
    b = 0.8,
    a = 0.2
}
function NS_WishLists_Master:DrawWLSOptionsFrame(container, instance_id, filter)
    if not filter then filter = "itemID" end 
    if _G[addonname.."_OptionsFrame"] then
        _G[addonname.."_OptionsFrame"]:Hide()
        _G[addonname.."_OptionsFrame"] = nil
    end
    
    local OptionsFrame = CreateFrame("Frame",addonname.."_OptionsFrame", container.content)
    OptionsFrame:SetPoint("TOPLEFT",0,0)
    OptionsFrame:SetPoint("BOTTOMRIGHT",0,0)
    OptionsFrame:SetToplevel(true);
    local scrollbgmain = OptionsFrame:CreateTexture(nil, "BACKGROUND")
    scrollbgmain:SetAllPoints(OptionsFrame)
    scrollbgmain:SetColorTexture(0, 0, 0, 0.3)

    local checkBoxesTitleEdit = OptionsFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
        checkBoxesTitleEdit:SetPoint("TOPLEFT", 17,-17)
        checkBoxesTitleEdit:SetJustifyH("LEFT")
        checkBoxesTitleEdit:SetJustifyV("MIDDLE")
        checkBoxesTitleEdit:SetText("Bloquer l'édition de wish list pour:")
        checkBoxesTitleEdit:SetHeight(20)
        checkBoxesTitleEdit:SetWidth(250)
    local cpt = 0
    for instance_id, instance in pairs(NS_WishLists_Master.Instances) do
        local checkboxEdit = CreateFrame("CheckButton", nil, OptionsFrame, "UICheckButtonTemplate");
            checkboxEdit:SetPoint("TOPLEFT", checkBoxesTitleEdit, "BOTTOMLEFT", 0, -(cpt*checkbox_height));
            checkboxEdit.text:SetWidth(160);
            checkboxEdit.text:SetText(" "..NS_WishLists_Master.Instances[instance_id].name);
            checkboxEdit.text:SetJustifyH("LEFT")
            checkboxEdit.text:Show();
            checkboxEdit:SetChecked(NS_WishLists_Master_Data_001["config"][instance_id]["edit_locked"])
            checkboxEdit:SetScript("OnMouseUp", function(self)
                self:SetChecked(self:GetChecked());
                NS_WishLists_Master_Data_001["config"][instance_id]["edit_locked"] = not NS_WishLists_Master_Data_001["config"][instance_id]["edit_locked"]
            end)
        cpt = cpt + 1
    end
    local checkBoxesTitleCreate = OptionsFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
        checkBoxesTitleCreate:SetPoint("TOPLEFT", checkBoxesTitleEdit, "BOTTOMLEFT", 0, -((cpt+1)*checkbox_height));
        checkBoxesTitleCreate:SetJustifyH("LEFT")
        checkBoxesTitleCreate:SetJustifyV("MIDDLE")
        checkBoxesTitleCreate:SetText("Bloquer la création de wish list pour:")
        checkBoxesTitleCreate:SetHeight(20)
        checkBoxesTitleCreate:SetWidth(250)
    cpt = 0
    for instance_id, instance in pairs(NS_WishLists_Master.Instances) do
        local checkboxCreate = CreateFrame("CheckButton", nil, OptionsFrame, "UICheckButtonTemplate");
            checkboxCreate:SetPoint("TOPLEFT", checkBoxesTitleCreate, "BOTTOMLEFT", 0, -(cpt*checkbox_height));
            checkboxCreate.text:SetWidth(160);
            checkboxCreate.text:SetText(" "..NS_WishLists_Master.Instances[instance_id].name);
            checkboxCreate.text:SetJustifyH("LEFT")
            checkboxCreate.text:Show();
            checkboxCreate:SetChecked(NS_WishLists_Master_Data_001["config"][instance_id]["create_locked"])
            checkboxCreate:SetScript("OnMouseUp", function(self)
                self:SetChecked(self:GetChecked());
                NS_WishLists_Master_Data_001["config"][instance_id]["create_locked"] = not NS_WishLists_Master_Data_001["config"][instance_id]["create_locked"]
            end)
        cpt = cpt + 1
    end
    OptionsFrame.checkBoxesTitleEdit = checkBoxesTitleEdit
    --OptionsFrame.WLSUsersList =
    return OptionsFrame

end

function NS_WishLists_Master:DrawWLSUsersList(container, instance_id)
    local backdrop1 = {
        bgFile = [[Interface\Tooltips\UI-Tooltip-Background]],
        edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]], edgeSize = 16,
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    }
    local OptionsFrame;
    if not container then return else OptionsFrame = container end
    if not NS_WishLists_Master_Data_001["config"] then
        NS_WishLists_Master_Data_001["config"] = {}
    end
    if not NS_WishLists_Master_Data_001["config"]["general"] then
        NS_WishLists_Master_Data_001["config"]["general"] = {}
    end
    if not NS_WishLists_Master_Data_001["config"]["general"]["displayAll"] then
        NS_WishLists_Master_Data_001["config"]["general"]["displayAll"] = true
    end
    -- ScrollingMessageFrame1
    local WLSplayerBank = CreateFrame("FRAME", addonname.."_WLSplayerBank", container)
        WLSplayerBank:SetPoint("TOPLEFT",OptionsFrame.checkBoxesTitleEdit,"TOPRIGHT", 0,0)
        WLSplayerBank:SetHeight(360)
        WLSplayerBank:SetWidth(200)

    local Title = WLSplayerBank:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
        Title:SetPoint("TOPLEFT",WLSplayerBank,"TOPLEFT",10,0)
        Title:SetJustifyH("LEFT")
        Title:SetHeight(19)
        Title:SetWidth(200)
        Title:SetText("Joueurs connus:")

        -- ScrollingMessageFrame1
        WLSplayerBank.scrollMotherFrame = CreateFrame("Frame",  addonname.."_WLSplayerBank_scrollmother", WLSplayerBank)
        WLSplayerBank.scrollMotherFrame:SetPoint("TOPLEFT", 0, -20)
        WLSplayerBank.scrollMotherFrame:SetHeight(370)
        WLSplayerBank.scrollMotherFrame:SetWidth(200)
        WLSplayerBank.scrollMotherFrame:SetBackdrop(backdrop1)
        WLSplayerBank.scrollMotherFrame:SetBackdropColor(0, 0, 0.1)
        WLSplayerBank.scrollMotherFrame:SetBackdropBorderColor(0.8, 0.8, 0.8)

        WLSplayerBank.scrollFrame = CreateFrame("ScrollFrame", nil, WLSplayerBank.scrollMotherFrame, "UIPanelScrollFrameTemplate")
        WLSplayerBank.scrollFrame:SetPoint("TOPLEFT", 5, -8)
        WLSplayerBank.scrollFrame:SetPoint("BOTTOMRIGHT", -30, 5)
        WLSplayerBank.scrollFrame:EnableMouseWheel(true)
        WLSplayerBank.scrollFrame:EnableMouse(true)

        WLSplayerBank.scrollbg2 = WLSplayerBank.scrollFrame:CreateTexture(nil, "BACKGROUND")
        WLSplayerBank.scrollbg2:SetAllPoints(true)
        WLSplayerBank.scrollbg2:SetColorTexture(0, 0, 0, 0.9)

        WLSplayerBank.cnt = CreateFrame("Frame", addonname.."_WLSplayerBank_cnt", WLSplayerBank.scrollMotherFrame)
        WLSplayerBank.cnt:SetPoint("TOPLEFT", WLSplayerBank.scrollFrame, "TOPLEFT", 0, 0)
        WLSplayerBank.cnt:SetPoint("TOPRIGHT", WLSplayerBank.scrollFrame, "TOPRIGHT", 0, 0)
        WLSplayerBank.cnt:SetHeight(340)
        WLSplayerBank.cnt:SetWidth(200)

        WLSplayerBank.scrollFrame:SetScrollChild(WLSplayerBank.cnt)

        WLSplayerBank.scrollbg3 = WLSplayerBank.cnt:CreateTexture(nil, "BACKGROUND")
        WLSplayerBank.scrollbg3:SetAllPoints(true)
        WLSplayerBank.scrollbg3:SetColorTexture(0, 0, 0, 0.9)
        --menu ou bouton============================================================
        local displayAll = CreateFrame("CheckButton", nil, WLSplayerBank, "UICheckButtonTemplate");
            displayAll:SetPoint("TOPLEFT",WLSplayerBank.scrollMotherFrame,"BOTTOMLEFT", 0, 2);
            displayAll.text:SetWidth(160);
            displayAll.text:SetText(" tout afficher");
            displayAll.text:SetJustifyH("LEFT")
            displayAll.text:Show();
            displayAll:SetChecked(NS_WishLists_Master_Data_001["config"]["general"]["displayAll"])
            displayAll:SetScript("OnMouseUp", function(self)
                self:SetChecked(self:GetChecked());
                NS_WishLists_Master_Data_001["config"]["general"]["displayAll"] = not NS_WishLists_Master_Data_001["config"]["general"]["displayAll"]
            end)
        WLSplayerBank.displayAll = displayAll
        -- ============================================================
        pair_ = false
        --************
    local FillList = function(self)
        pair_ = false
        if WLSplayerBank then
            WLSplayerBank.cnt:Hide()
            WLSplayerBank.cnt = CreateFrame("Frame", addonname.."_WLSplayerBank_cnt", WLSplayerBank.scrollMotherFrame)
            WLSplayerBank.cnt:SetPoint("TOPLEFT", WLSplayerBank.scrollFrame, "TOPLEFT", 0, 0)
            WLSplayerBank.cnt:SetPoint("TOPRIGHT", WLSplayerBank.scrollFrame, "TOPRIGHT", 0, 0)
            WLSplayerBank.cnt:SetHeight(340)
            WLSplayerBank.cnt:SetWidth(200)
            WLSplayerBank.cnt:Show()

            WLSplayerBank.scrollFrame:SetScrollChild(WLSplayerBank.cnt)
            -- Grab >= from guild roster
            NS_WishLists_Master:getGuildRoster()
            local parsed_users = {}
            local found = false
            if not NS_WishLists_Master_Data_001["guild_roster"] then NS_WishLists_Master_Data_001["guild_roster"]={} end
                
            NS_WishLists_Master:ParseAllWLS()

            local all_wls = NS_WishLists_Master.allWLS()

            for user_name, user in pairs(NS_WishLists_Master_Data_001["guild_roster"])  do
                if user.user_name then
                    if #user.user_name >= 3 then
                        if user.level >= 58 then
                            parsed_users[user.user_name] = {}
                            parsed_users[user.user_name].name = user.user_name
                            parsed_users[user.user_name].level = user.level
                            parsed_users[user.user_name].class = user.user_classef
                            parsed_users[user.user_name].rank = user.rank
                            parsed_users[user.user_name].classColor = RAID_CLASS_COLORS[user.user_classef] or RAID_CLASS_COLORS["PRIEST"]
                        end
                    end
                end
            end

            for user_name, user in pairs(NS_WishLists_Master_Data_001["receivedUsers"])  do
                if user_name then
                    if #user_name >= 3 then
                        if user["infos"] then
                            if user["infos"].level >= 58 then
                                if not parsed_users[user_name] then
                                    parsed_users[user_name] = {}
                                end
                                parsed_users[user_name].name  = user_name;
                                parsed_users[user_name].level = user["infos"].level;
                                parsed_users[user_name].class = user["infos"]["classe"]["englishClass"];
                                parsed_users[user_name].race  = user["infos"].race;
                                parsed_users[user_name].classColor = RAID_CLASS_COLORS[user["infos"]["classe"]["englishClass"]] or RAID_CLASS_COLORS["PRIEST"]
                            end
                        else
                            NS_WishLists_Master_Data_001["receivedUsers"][user_name] = nil
                        end
                    end
                end
            end
            local t_names = {}
            for k, v in pairs(parsed_users) do
                tinsert(t_names, k)
            end
            table.sort(t_names)
            local cpt1 = 1
            for k, v in pairs(t_names) do
                local userInfos = parsed_users[v]
                local c = {}
                if pair_ then
                    c = drk_lines
                else
                    c = clr_lines
                end
                pair_ = not pair_
                local playerFrame = CreateFrame("Button", addonname.."_WLSplayerFrame"..k, WLSplayerBank.cnt)
                playerFrame:EnableMouse(true)
                playerFrame:SetWidth(180)
                playerFrame:SetHeight(20)
                playerFrame:SetScript("OnClick", function(self)
                   -- print("username: "..v..".")
                    NS_WishLists_Master.SelectedUsername = v;
                    if NS_WishLists_Master.userLockFrame then
                        NS_WishLists_Master.userLockFrame:Hide()
                        NS_WishLists_Master.userLockFrame = nil
                    end

                    local userLockFrame = CreateFrame("Frame", nil, WLSplayerBank)
                        userLockFrame:SetPoint("TOPLEFT", WLSplayerBank.scrollFrame, "TOPRIGHT", 35, 0)
                        userLockFrame:SetHeight(300)
                        userLockFrame:SetWidth(250)
                    local labeluserLock = userLockFrame:CreateFontString(nill, "BACKGROUND", "GameFontHighlight")
                        labeluserLock:SetPoint("TOPLEFT",0,0)
                        labeluserLock:SetJustifyH("CENTER")
                        labeluserLock:SetJustifyV("MIDDLE")
                        local classColor = userInfos.classColor
                        labeluserLock:SetTextColor(classColor.r, classColor.g, classColor.b)
                        labeluserLock:SetText(v)
                        labeluserLock:SetHeight(19)
                        labeluserLock:SetWidth(250)
                        local highlight1 = userLockFrame:CreateTexture(nil, "HIGHLIGHT")
                        highlight1:SetAllPoints(labeluserLock)
                        highlight1:SetColorTexture(0.5, 0.5, 0.9, 0.8)
                        highlight1:SetBlendMode("ADD")
                        local highlight1bg = userLockFrame:CreateTexture(nil, "BACKGROUND")
                        highlight1bg:SetAllPoints(labeluserLock)
                        highlight1bg:SetColorTexture(0.8, 0, 0.8, 0.5)
                        highlight1bg:SetBlendMode("ADD")

                        local checkBoxesTitleEdit = userLockFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
                            checkBoxesTitleEdit:SetPoint("TOPLEFT", labeluserLock, "BOTTOMLEFT", 0, -10)
                            checkBoxesTitleEdit:SetJustifyH("LEFT")
                            checkBoxesTitleEdit:SetJustifyV("MIDDLE")
                            checkBoxesTitleEdit:SetText("Bloquer l'édition de wish list pour:")
                            checkBoxesTitleEdit:SetHeight(20)
                            checkBoxesTitleEdit:SetWidth(250)
                        local cpt = 0
                        for instance_id, instance in pairs(NS_WishLists_Master.Instances) do
                            if not NS_WishLists_Master_Data_001["config"][instance_id]["users_locks"] then NS_WishLists_Master_Data_001["config"][instance_id]["users_locks"] = {} end
                            if not NS_WishLists_Master_Data_001["config"][instance_id]["users_locks"][v] then NS_WishLists_Master_Data_001["config"][instance_id]["users_locks"][v] = {} end
                            if not NS_WishLists_Master_Data_001["config"][instance_id]["users_locks"][v]["edit_locked"] then NS_WishLists_Master_Data_001["config"][instance_id]["users_locks"][v]["edit_locked"] = NS_WishLists_Master_Data_001["config"][instance_id]["edit_locked"] end
                            local checkboxEdit = CreateFrame("CheckButton", nil, userLockFrame, "UICheckButtonTemplate");
                                checkboxEdit:SetPoint("TOPLEFT", checkBoxesTitleEdit, "BOTTOMLEFT", 0, -(cpt*checkbox_height));
                                checkboxEdit.text:SetWidth(160);
                                checkboxEdit.text:SetText(" "..NS_WishLists_Master.Instances[instance_id].name);
                                checkboxEdit.text:SetJustifyH("LEFT")
                                checkboxEdit.text:Show();
                                checkboxEdit:SetChecked(NS_WishLists_Master_Data_001["config"][instance_id]["users_locks"][v]["edit_locked"])
                                checkboxEdit:SetScript("OnMouseUp", function(self)
                                    self:SetChecked(self:GetChecked());
                                    NS_WishLists_Master_Data_001["config"][instance_id]["users_locks"][v]["edit_locked"] = not NS_WishLists_Master_Data_001["config"][instance_id]["users_locks"][v]["edit_locked"]
                                end)
                            cpt = cpt + 1
                        end
                        local checkBoxesTitleCreate = userLockFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
                            checkBoxesTitleCreate:SetPoint("TOPLEFT", checkBoxesTitleEdit, "BOTTOMLEFT", 0, -((cpt+1)*checkbox_height));
                            checkBoxesTitleCreate:SetJustifyH("LEFT")
                            checkBoxesTitleCreate:SetJustifyV("MIDDLE")
                            checkBoxesTitleCreate:SetText("Bloquer la création de wish list pour:")
                            checkBoxesTitleCreate:SetHeight(20)
                            checkBoxesTitleCreate:SetWidth(250)
                        cpt = 0
                        for instance_id, instance in pairs(NS_WishLists_Master.Instances) do
                            if not NS_WishLists_Master_Data_001["config"][instance_id]["users_locks"] then NS_WishLists_Master_Data_001["config"][instance_id]["users_locks"] = {} end
                            if not NS_WishLists_Master_Data_001["config"][instance_id]["users_locks"][v] then NS_WishLists_Master_Data_001["config"][instance_id]["users_locks"][v] = {} end
                            if not NS_WishLists_Master_Data_001["config"][instance_id]["users_locks"][v]["create_locked"] then NS_WishLists_Master_Data_001["config"][instance_id]["users_locks"][v]["create_locked"] = NS_WishLists_Master_Data_001["config"][instance_id]["create_locked"] end
                            local checkboxCreate = CreateFrame("CheckButton", nil, userLockFrame, "UICheckButtonTemplate");
                                checkboxCreate:SetPoint("TOPLEFT", checkBoxesTitleCreate, "BOTTOMLEFT", 0, -(cpt*checkbox_height));
                                checkboxCreate.text:SetWidth(160);
                                checkboxCreate.text:SetText(" "..NS_WishLists_Master.Instances[instance_id].name);
                                checkboxCreate.text:SetJustifyH("LEFT")
                                checkboxCreate.text:Show();
                                checkboxCreate:SetChecked(NS_WishLists_Master_Data_001["config"][instance_id]["users_locks"][v]["create_locked"])
                                checkboxCreate:SetScript("OnMouseUp", function(self)
                                    self:SetChecked(self:GetChecked());
                                    NS_WishLists_Master_Data_001["config"][instance_id]["users_locks"][v]["create_locked"] = not NS_WishLists_Master_Data_001["config"][instance_id]["users_locks"][v]["create_locked"]
                                end)
                            cpt = cpt + 1
                        end
                    NS_WishLists_Master.userLockFrame = userLockFrame
                end)
                --print("username: "..v..".")
                local labelplayer = playerFrame:CreateFontString(addonname.."_WLSplayerFrame_txt_"..k, "BACKGROUND", "GameFontHighlight")
                    labelplayer:SetPoint("TOPLEFT",0,0)
                    labelplayer:SetPoint("BOTTOMRIGHT",0,0)
                    labelplayer:SetJustifyH("CENTER")
                    labelplayer:SetJustifyV("MIDDLE")
                    local classColor = userInfos.classColor
                    labelplayer:SetTextColor(classColor.r, classColor.g, classColor.b)
                    labelplayer:SetText(v)
                    labelplayer:SetHeight(19)
                    labelplayer:SetWidth(180)
                    local highlight1 = playerFrame:CreateTexture(nil, "HIGHLIGHT")
                    highlight1:SetAllPoints(labelplayer)
                    highlight1:SetColorTexture(0.5, 0.5, 0.9, 0.8)
                    highlight1:SetBlendMode("ADD")
                    local highlight1bg = playerFrame:CreateTexture(nil, "BACKGROUND")
                    highlight1bg:SetAllPoints(labelplayer)
                    highlight1bg:SetColorTexture(c.r, c.g, c.b, c.a)
                    highlight1bg:SetBlendMode("ADD")
                playerFrame:SetPoint("TOPLEFT", 0, -(20+2)*(k-1))
            end
        end
    end
    FillList()
end
