-- Author      : ketch
-- Create Date : 12/9/2020 1:09:38 PM


local addonname, NSCom = ...
local _G = getfenv(0)
local NS_WishLists_Master =_G.NS_WishLists_Master

function NS_WishLists_Master:initData()
     if not NS_WishLists_Master_Data_001["receivedWLS"] then
         NS_WishLists_Master_Data_001["receivedWLS"] = {}
     end
    NS_WishLists_Master.Instance ={}
end

function NS_WishLists_Master:initInstance(instance_id)
    if not instance_id then
        --full init for all instance
        NS_WishLists_Master.Instance = {}
        for instance_id, instance1 in pairs(NS_WishLists_Master.Instances) do
            NS_WishLists_Master.Instance[instance_id] = {}
            NS_WishLists_Master.Instance[instance_id]["items"] = {}
            for idx1, itemid in ipairs(instance1["items"] ) do
                NS_WishLists_Master.Instance[instance_id]["items"][itemid] = {}
            end
        end
    else
        --instance not found so data was not initialised
        if not NS_WishLists_Master.Instance[instance_id] then
            NS_WishLists_Master:initInstance()
        else
            --instance found so reset instance to defaut
            for idx1, itemid in ipairs(NS_WishLists_Master.Instances[instance_id]) do
                NS_WishLists_Master.Instance[instance_id]["items"][itemid] = {}
            end
        end
    end
end

function NS_WishLists_Master:getInstanceIdByItem(itemID) 
    local instance_id_ = 0
    for instance_id, instance in pairs(NS_WishLists_Master.Instances) do
        for idx, itemid in ipairs(NS_WishLists_Master.Instances[instance_id][items]) do
            if itemid == itemID then
                instance_id_ = instance_id
                break
            end
        end
    end
    return instance_id_
end

function NS_WishLists_Master:getInstanceAllPrios(instance_id)
    NS_WishLists_Master:initInstance(instance_id);
    local all_wls = NS_WishLists_Master.allWLS()
    for user_name, user_wl in pairs(all_wls) do
        --TODO check if user must be computed
        for instance_id_curr, instance_curr in pairs(user_wl) do
            if instance_id_curr and instance_curr then
                for prio_name, itemid in pairs(instance_curr) do
                    if prio_name and itemid then
                        if not NS_WishLists_Master.Instance[instance_id_curr]["items"][itemid] then 
                            return
                        end
                        if not NS_WishLists_Master.Instance[instance_id_curr]["items"][itemid][prio_name] then
                            NS_WishLists_Master.Instance[instance_id_curr]["items"][itemid][prio_name] = {}
                        end
                        local prio_user = user_name; --getUserData(user_name);
                        local alreadyInDB = false;
                        
                        for k,v in ipairs(NS_WishLists_Master.Instance[instance_id_curr]["items"][itemid][prio_name]) do
                            if v == user_name then
                                alreadyInDB = true;
                            end
                        end

                        if not alreadyInDB then
                            tinsert(NS_WishLists_Master.Instance[instance_id_curr]["items"][itemid][prio_name],prio_user);
                        end
                    end
                end
            end
        end
    end
    NS_WishLists_Master_Data_001["tempTest"] = NS_WishLists_Master.Instance
end

function NS_WishLists_Master:resetAll()
    NS_WishLists_Master:initData();
    NS_WishLists_Master:initInstance(nil);
end
function NS_WishLists_Master:ParseAllWLS()
    NS_WishLists_Master:resetAll();
     for instance_id, instance in pairs(NS_WishLists_Master.Instances) do
       NS_WishLists_Master:getInstanceAllPrios(instance_id)
    end
end

