-- Author      : ketch
-- Create Date : 3/17/2020 11:58:22 AM
local addonname, NS_WishLists_Master = ...
local _G = getfenv(0)
local NS_WishLists_Master =_G.NS_WishLists_Master

local LibDialog = LibStub("LibDialog-1.0")
local lwin = LibStub("LibWindow-1.1")


--NS_WishLists_Master.framelootsurvey_count = 0
local getn, PlaySound, GuildRoster = table.getn, PlaySound, GuildRoster

-- UI
function NS_WishLists_Master:HideAll()
    if NS_WishLists_Master.SourisGif then
        NS_WishLists_Master.SourisGif:Hide()
        NS_WishLists_Master.SourisGif.sourisGif:Hide()
        NS_WishLists_Master.SourisGif.TabAboutHtml:Hide()
    end
    if NS_WishLists_Master.frameVAbout then
        NS_WishLists_Master.frameVAbout:Hide()
    end

    if NS_WishLists_Master.frameVersionsLogs then
        NS_WishLists_Master.frameVersionsLogs:Hide()
    end
    
    if NS_WishLists_Master.currentWlTab then
        NS_WishLists_Master.currentWlTab:Hide()
    end
    if NS_WishLists_Master.currentWlTabMWL then
        NS_WishLists_Master.currentWlTabMWL:Hide()
    end
    if NS_WishLists_Master.ItemList then
        NS_WishLists_Master.ItemList:Hide()
    end

    if NS_WishLists_Master.frameTabStuff then
        NS_WishLists_Master.frameTabStuff:Hide()
    end
    if NS_WishLists_Master.ExportMyWL then
        NS_WishLists_Master.ExportMyWL:Hide()
    end
    if NS_WishLists_Master.ImportWLs then
        NS_WishLists_Master.ImportWLs:Hide()
    end
    if NS_WishLists_Master.WLSRecapFrame then
        NS_WishLists_Master.WLSRecapFrame:Hide()
    end
    if NS_WishLists_Master.WLSOptionsFrame then
        NS_WishLists_Master.WLSOptionsFrame:Hide()
    end
    if NS_WishLists_Master.WLSUsersList then
        NS_WishLists_Master.WLSUsersList:Hide()
    end
    if NS_WishLists_Master.Looteditems then
        NS_WishLists_Master.Looteditems:Hide()
    end
    if NS_WishLists_Master.LootedItemRecapFrame then
        NS_WishLists_Master.LootedItemRecapFrame:Hide()
    end
end
--Tabs Menu
function NS_WishLists_Master.SelectGroup(container, event, group)
    container:ReleaseChildren()
    -- todo factorise
    NS_WishLists_Master:HideAll()

    if     group == "tabMain1" then
        NS_WishLists_Master:DrawIndWLsFrame(container)
    elseif group == "tabMain2" then
        NS_WishLists_Master:DrawRecapsFrame(container)
    elseif group == "tabMain3" then
        NS_WishLists_Master.Looteditems = NS_WishLists_Master:DrawTabLooteditems(container)
    elseif group == "tabMain4" then
        NS_WishLists_Master.ImportWLs = NS_WishLists_Master:DrawImportWLsTabs(container)
    elseif group == "tabMain5" then
        NS_WishLists_Master:ParseAllWLS()
        NS_WishLists_Master.ExportMyWL = NS_WishLists_Master:DrawExportMyWLTabs(container)
    elseif group == "tabMain6" then
        NS_WishLists_Master.WLSOptionsFrame = NS_WishLists_Master:DrawWLSOptionsFrame(container)
        NS_WishLists_Master.WLSUsersList = NS_WishLists_Master:DrawWLSUsersList(NS_WishLists_Master.WLSOptionsFrame, instance_id)
    elseif group == "tabMain7" then
        NS_WishLists_Master.SourisGif = NS_WishLists_Master:DrawSourisGif(container)
    end
end

function NS_WishLists_Master.SelectGroup2(container, event, group)
    container:ReleaseChildren()
    -- todo factorise
    NS_WishLists_Master:HideAll()
    local target_id = 0
    if     group == "tabIndWLs1" or group == "tabRecaps1" or group =="tabLootedItems1" then
        target_id = 409        
    elseif group == "tabIndWLs2" or group == "tabRecaps2" or group =="tabLootedItems2" then
        target_id = 249
    elseif group == "tabIndWLs3" or group == "tabRecaps3" or group =="tabLootedItems3" then
        target_id = 469
    elseif group == "tabIndWLs4" or group == "tabRecaps4" or group =="tabLootedItems4" then
        target_id = 309
    elseif group == "tabIndWLs5" or group == "tabRecaps5" or group =="tabLootedItems5" then
        target_id = 509
    elseif group == "tabIndWLs6" or group == "tabRecaps6" or group =="tabLootedItems6" then
        target_id = 531
    elseif group == "tabIndWLs7" or group == "tabRecaps7" or group =="tabLootedItems7" then
        target_id = 533
    elseif group == "tabIndWLs8" or group == "tabRecaps8" or group =="tabLootedItems8" then
        target_id = 1
    end

    local group_type = group.sub(group,1, #group-1)
    --print(group_type)
    if target_id > 0 then
        if      group_type == "tabIndWLs" then
            NS_WishLists_Master.currentWlTab, NS_WishLists_Master.ItemList = NS_WishLists_Master:DrawGuildRoster(container,target_id)
            NS_WishLists_Master:fillTargetWishList(target_id,nil)

        elseif  group_type == "tabRecaps" then
            NS_WishLists_Master.WLSRecapFrame = NS_WishLists_Master:DrawWLSRecapFrame(container, target_id)

        elseif  group_type == "tabLootedItems" then
            NS_WishLists_Master.LootedItemRecapFrame = NS_WishLists_Master:DrawLootedItemRecapFrame(container, target_id)
        end
    end
end

function NS_WishLists_Master:DrawRecapsFrame(container)
    -- **************************************************
    -- *                    frameWL               *
    -- **************************************************
    -- create a scrollframe inside wl_frame_rslt
    local RecapsFrame = NS_WishLists_Master.AceGUI:Create("SimpleFrame")
    RecapsFrame:SetPoint("TOPLEFT", 0, 0)
    RecapsFrame:SetFullWidth(true)
    RecapsFrame:SetLayout("Fill")
    RecapsFrame:Show()
    container:AddChild(RecapsFrame)
    -- Create the TabGroup
    local tabRecaps = NS_WishLists_Master.AceGUI:Create("TabGroup")
    tabRecaps:SetLayout("Flow")
    -- Setup which tabs to show
    
    tabRecaps:SetTabs({
        { text = "Molten Core"      , value = "tabRecaps1" },
        { text = "Onyxia"           , value = "tabRecaps2" },
        { text = "Blackwing Lair"   , value = "tabRecaps3" },
        { text = "Zul'Gurub"        , value = "tabRecaps4" },
        { text = "Ahn Quiraj 20"    , value = "tabRecaps5" },
        { text = "Ahn Quiraj 40"    , value = "tabRecaps6" },
        { text = "Naxxramas"        , value = "tabRecaps7" }
    })
    
    -- Register callback
    tabRecaps:SetCallback("OnGroupSelected", NS_WishLists_Master.SelectGroup2)
    -- Set initial Tab (this will fire the OnGroupSelected callback)
    tabRecaps:SelectTab("tabRecaps7")
    -- add to the frame container
    RecapsFrame:AddChild(tabRecaps)
end
function NS_WishLists_Master:DrawIndWLsFrame(container)
    -- **************************************************
    -- *                    frameWL               *
    -- **************************************************
    -- create a scrollframe inside wl_frame_rslt
    local IndWLsFrame = NS_WishLists_Master.AceGUI:Create("SimpleFrame")
    IndWLsFrame:SetPoint("TOPLEFT", 0, 0)
    IndWLsFrame:SetFullWidth(true)
    IndWLsFrame:SetLayout("Fill")
    IndWLsFrame:Show()
    container:AddChild(IndWLsFrame)
    -- Create the TabGroup
    local tabIndWLs = NS_WishLists_Master.AceGUI:Create("TabGroup")
    tabIndWLs:SetLayout("Flow")
    -- Setup which tabs to show
    
    tabIndWLs:SetTabs({
        { text = "Molten Core"      , value = "tabIndWLs1" },
        { text = "Onyxia"           , value = "tabIndWLs2" },
        { text = "Blackwing Lair"   , value = "tabIndWLs3" },
        { text = "Zul'Gurub"        , value = "tabIndWLs4" },
        { text = "Ahn Quiraj 20"    , value = "tabIndWLs5" },
        { text = "Ahn Quiraj 40"    , value = "tabIndWLs6" },
        { text = "Naxxramas"        , value = "tabIndWLs7" }
    })
    
    -- Register callback
    tabIndWLs:SetCallback("OnGroupSelected", NS_WishLists_Master.SelectGroup2)
    -- Set initial Tab (this will fire the OnGroupSelected callback)
    tabIndWLs:SelectTab("tabIndWLs7")
    -- add to the frame container
    IndWLsFrame:AddChild(tabIndWLs)
end
--SHOW
function NS_WishLists_Master:Show()
    NS_WishLists_Master.frame = NS_WishLists_Master.AceGUI:Create("FrameExt2",addonname.."_MainFrameName")
    NS_WishLists_Master.frame:SetTitle(NS_WishLists_Master.versionName)
    NS_WishLists_Master.frame:SetCallback("OnClose", function(widget) 
        NS_WishLists_Master.frame:Hide()
    end)
    -- Fill Layout - the TabGroup widget will fill the whole frame
    NS_WishLists_Master.frame:SetLayout("Fill")
    NS_WishLists_Master.frame:Show()
    NS_WishLists_Master.frame:SetWidth(970)
    NS_WishLists_Master.frame:SetHeight(550)
    -- Create the TabGroup
    local tabMain = NS_WishLists_Master.AceGUI:Create("TabGroup")
    tabMain:SetLayout("Flow")
    -- Setup which tabs to show
    tabMain:SetTabs({
        { text = "Wish Lists Manager"   , value = "tabMain1" },
        { text = "Merged Wish Lists"    , value = "tabMain2" },
        { text = "Looted Items"         , value = "tabMain3" },
        { text = "Import"               , value = "tabMain4" },
        { text = "Export"               , value = "tabMain5" },
        { text = "Options"              , value = "tabMain6" },
        { text = "About"                , value = "tabMain7" }
    })
    -- Register callback
    tabMain:SetCallback("OnGroupSelected", NS_WishLists_Master.SelectGroup)
    -- Set initial Tab (this will fire the OnGroupSelected callback)
    tabMain:SelectTab("tabMain1")
    -- add to the frame container
    NS_WishLists_Master.frame:AddChild(tabMain)
    NS_WishLists_Master.MainTabGroup = tabMain
    NS_WishLists_Master.frame:SetCallback("OnEvent", NS_WishLists_Master.OnEvent)
    _G[addonname.."_MainFrameName"] = NS_WishLists_Master.frame.frame--todo
    tinsert(UISpecialFrames,addonname.."_MainFrameName");
end
